<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8">
  <title>Form work1</title>
  <script>
    /*
      Задание:
        Сделать шиблонизатор элемента по:
        Ширине input type=range
        Цвету  input type=color
        Высоте input type=number
        Скругление углов input type=number
        Margin input type=number

      Свойсвта: https://developer.mozilla.org/en-US/docs/Web/CSS/CSS_Properties_Reference

      Бонус:
        + Сделать выборку цвета из рандомных 20 цветов которые выбираются из появившегося блока :
        https://s3.envato.com/files/230412754/screenshots/1.png
        За заготовку для рандома цвета использовать функцию из первых занятий.

    */

    window.addEventListener("load", function () {
      var myWidth = document.getElementById('myWidth'),
          myHeight = document.querySelector('input[name="height"]'),
          myMargin = document.querySelector('input[name="margin"]'),
          myBorderRadius = document.querySelector('input[name="borderRadius"]'),
          myBgCo = document.querySelector('button[name="bgCo"]');

      myWidth.addEventListener('input', function(event){
        result.style.width = this.value + 'px';
      });
      myHeight.addEventListener('input', function(event){
        result.style.height = this.value + 'px';
      });
      myMargin.addEventListener('input', function(event){
        result.style.margin = this.value + 'px';
      });
      myBorderRadius.addEventListener('input', function(event){
        result.style.borderRadius = this.value + '%';
      });
      myBgCo.addEventListener('click', function(event){
        var listColor = document.querySelector(".list_color");

        listColor.innerHTML = null;

        for(var i = 0; i < 20; i++){
          var item = document.createElement('div'),
              color =  randColor();

          item.style.backgroundColor = color;
          item.classList.add('item')
          listColor.appendChild(item);

          item.addEventListener('click', function(){
            var items = document.querySelectorAll('.item');
            items.forEach(function (el){
              el.classList.remove('active');
              console.log('1')
            });
            result.style.backgroundColor = this.style.backgroundColor;
            this.classList.add('active');
          })
        }
      });

      document.querySelector('form').addEventListener('submit', function(e){
        e.preventDefault();
      })

      function randColor(){
        var color = '#';

        for (let i = 0; i < 6; i++){
          seg = randNum(0, 15).toString(16);
          color += seg;
        }

        return color;
      }

      //Random number
      function randNum(min, max){
        return Math.round(Math.random() * (max - min) + min);
      }

    });
  </script>
</head>
<body>
  <div class="Templating">
    <form>
      <label>
        Width:
        <input type="range" id="myWidth" min="10" max="500" step="10" value="10"/>
      </label>
      <label>
        Height:
        <input type="range" name="height" min="10" max="500" step="10" value="10">
      </label>
      <label>
        BorderRadius:
        <input type="range" name="borderRadius" min="0" max="50" step="1" value="0">
      </label>
      <label>
        Margin:
        <input type="range" name="margin" min="0" max="100" step="1" value="0">
      </label>
      <label>
        <button name="bgCo">Change color</button>
        <!-- <input type="color" name="bgCo" id="myColor"/> -->
      </label>
    </form>

    <div class="TemplatingResult">
      <div id="result" class="result"></div>
    </div>
    <div class="list_color">

    </div>
  </div>




  <style>
    button[name="bgCo"]{
      margin-top: 10px;
    }
    form{
      margin-bottom: 30px;
    }
    label{
      display: block;
    }
    .list_color{
      width: 590px;
      display: flex;
      justify-content: space-between;
      flex-wrap: wrap;
      margin-top: 20px;
    }
    .item{
      width: 100px;
      height: 100px;
      border-radius: 50%;
      margin-bottom: 20px;
      cursor: pointer;
      position: relative;
    }
    .item::before{
      content: '✔';
      display: none;
      position: absolute;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
      font-size: 30px;
    }
    .item.active::before{
      display: block;
    }
    .result{
      width: 50px;
      background: gray;
      box-sizing: border-box;
      padding: 10px;
    }
    #MyValidateForm{
      width: 350px;
      display: flex;
      flex-direction: column;
    }

    #MyValidateForm input{
      margin-bottom: 10px;
      box-sizing: border-box;
      padding: 10px 20px;
    }
  </style>
</body>
</html>
